/*
 * $Id: hparser2.prg,v 1.1 1999/11/09 01:37:24 vszel Exp $
 */

//*******************************************************************
// hparser2.prg: Hessmark parser(2): a '#'-al kezdd sorok elemzse.
// 1999, Csiszr Levente

//*******************************************************************
#include "objgen.ch"

//*******************************************************************
#define _STRICT_PARENT_
#include "token.och"
//#include "mmarker.och"
//#include "rmarker.och"
//#include "maltrset.och"
//#include "rsmmarkr.och"
//#include "ralter.och"
#include "edefdict.och"
#include "defdict.och"
//#include "extrdict.och"
//#include "xtrdict.och"
// #include "freader.och"
//#include "incl.och"
//#include "prserr.och"
//*******************************************************************
// #include "cr_lf.ch"
#include "ctoken.ch"
// #include "prserr.ch"

//*******************************************************************
#include "hparser.ch"

//*******************************************************************
#include "reader.och"
#include "treader.och"
#include "hparser.och"

//*******************************************************************
#xtranslate this:<m> => HPARSER.(this):<m>

//*******************************************************************
function hpr_prsDefine(this,mNameToken)
// A # define elemzje.
local state,tkId,tkStr
local name,params
local ujsor

#ifdef ID_STRING
   #define ST_D_START             "start"
   #define ST_D_TORZS             "torzs"
   #define ST_D_PARAM_VAGY_TORZS  "param_vagy_torzs"
   #define ST_D_TORZS_START       "torzs_start"
   #define ST_D_PARAM_START       "param_start"
   #define ST_D_PARAM_NEVUTAN     "param_nevutan"
   #define ST_D_PARAM_VESSZOUTAN  "param_vesszoutan"
#else
   #define ST_D_START             1
   #define ST_D_TORZS             2
   #define ST_D_PARAM_VAGY_TORZS  3
   #define ST_D_TORZS_START       4
   #define ST_D_PARAM_START       5
   #define ST_D_PARAM_NEVUTAN     6
   #define ST_D_PARAM_VESSZOUTAN  7
#endif               
   state:=ST_D_START
   this:rds()
   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS
      if (state==ST_D_START)
         if (ujsor)
            // Hibs s vge is van.
            this:errorgen(mNameToken,HPRERR_SDEFINE)
            exit
         elseif (tkId==TKID_URES)
            // Eldobjuk.
            state:=ST_D_START
         elseif (tkId==TKID_NEV)
            // Ez a neve
            name:=tkStr
            state:=ST_D_PARAM_VAGY_TORZS
         else
            // Hibs.
            this:errorgen(this:item,HPRERR_SDEFINE)
            exit
         endif
      elseif (state==ST_D_PARAM_VAGY_TORZS)
         if (ujsor)
            // A definci res.
            this:unrds()
            this:clearParserbuffer()
            this:addDefine(mNameToken,name,params)
            // this:putParserBuffer(this:item)
            exit
         elseif (tkId==TKID_URES)
            // tmegynk a trzshz.
            this:clearParserbuffer()
            state:=ST_D_TORZS_START
         elseif (tkId==TKID_CHAR .and. tkStr=="(")
            // A paramterek.
            state:=ST_D_PARAM_START
         else
            // A trzs.
            this:clearParserBuffer()
            this:putParserBuffer(this:item)
            state:=ST_D_TORZS
         endif
      elseif (state==ST_D_PARAM_START)
         // '(' utn. Nv vagy ')' jhet.
         params:={}
         if (tkId==TKID_URES)
            // Eldobjuk.
         elseif (tkId==TKID_CHAR .and. tkStr==")")
            // Kezddik a trzs.
            this:clearParserbuffer()
            state:=ST_D_TORZS_START
         elseif (tkId==TKID_NEV)
            // Paramter.
            aadd(params,tkStr)
            state:=ST_D_PARAM_NEVUTAN
         else
            // Brmi ms, az nem j! Ebben benne van az j sor is!
            // Hibs s vge is van.
            this:errorgen(mNameToken,HPRERR_LDEFINE)
            exit
         endif
      elseif (state==ST_D_PARAM_NEVUTAN)
         // Paramterlistban egy nv utn.
         // ',' vagy ')' jhet.
         if (tkId==TKID_URES)
            // Eldobjuk.
         elseif (tkId==TKID_CHAR .and. tkStr==")")
            // Kezddik a trzs.
            // res paramter lista.
            this:clearParserBuffer()
            state:=ST_D_TORZS_START
         elseif (tkId==TKID_CHAR .and. tkStr==",")
            // Kezddik a kvetkez paramter.
            state:=ST_D_PARAM_VESSZOUTAN
         else
            // Brmi ms, az nem j! Ebben benne van az j sor is!
            // Hibs s vge is van.
            this:errorgen(mNameToken,HPRERR_PDEFINE)
            exit
         endif
      elseif (state==ST_D_PARAM_VESSZOUTAN)
         // ',' utn. Csak nv jhet.
         if (tkId==TKID_URES)
            // Eldobjuk.
         elseif (tkId==TKID_NEV)
            // Paramter.
            aadd(params,tkStr)
            state:=ST_D_PARAM_NEVUTAN
         else
            // Brmi ms, az nem j! Ebben benne van az j sor is!
            // Hibs s vge is van.
            this:errorgen(mNameToken,HPRERR_PDEFINE)
            exit
          endif
      elseif (state==ST_D_TORZS_START)
         // Az reseket lenyeljk.
         if (tkId==TKID_URES)
            // Eldobjuk.
            this:unputParserBuffer()
         elseif (tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS)
            // Vge a definicinak.
            this:unrds()
            this:addDefine(mNameToken,name,params)
            exit
         else
            // Brmi ms, indul a trzs.
            state:=ST_D_TORZS
          endif
      elseif (state==ST_D_TORZS)
         if (tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS)
            // Vge a definicinak.
            this:unrds()
            this:addDefine(mNameToken,name,params)
            exit
         else
            // Brmi ms a trzs folytatdik.
         endif
      else
         ? "HPARSER:parseDefine(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rds()
   end while
   this:sorNyel()
   
return nil

//*******************************************************************
function hpr_prsUndef(this,mnameToken)
// A # undef elemzje.

local state

#ifdef ID_STRING
   #define ST_UD_START             "start"
   #define ST_UD_VEGE              "vege"
#else
   #define ST_UD_START             1
   #define ST_UD_VEGE              2
#endif

local tkId,tkStr
local name
local ujsor
               
   state:=ST_UD_START
   this:rds()
   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS
      if (state==ST_UD_START)
         if (ujsor)
            // Hibs s vge is van.
            this:errorgen(mnameToken,HPRERR_SUNDEF)
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         elseif (tkId==TKID_NEV)
            // Ez a neve
            name:=tkStr
            state:=ST_UD_VEGE
         else
            // Hibs.
            this:errorgen(mnameToken,HPRERR_SUNDEF)
            exit
         endif
      elseif (state==ST_UD_VEGE)
         if (ujsor)
            // Ksz vagyunk.
            this:unrds()
            this:clearParserbuffer()
            // Nem kell hibt jelezni, ha nincs.
            DEFDICT.(this:defdict):delKey(name)
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         else
            // Hibs
            this:errorgen(this:item,HPRERR_SUNDEF)
            exit
         endif
      else
         ? "HPARSER:parseUndef(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rds()
   end while
   this:sorNyel()
   
return nil

//*******************************************************************
function hpr_addDefine(this,mnameToken,name,params)
// A trzs a parserBuffer-ben van.
// Az mNameToken jelzi, hogy hol volt a definci.
local w,prev,errStr

   w:=C.EDEFDICT:onew(name,params,;
                      this:arrayParserBuffer(),;
                      TOKEN.mnameToken:file,;
                      TOKEN.mnameToken:line,;
                      TOKEN.mnameToken:pos)

   this:clearParserBuffer()

   if (nil!=(prev:=DEFDICT.(this:defdict):add(w)))
      // Mr van ilyen makr
      errStr:="Previous: "+;
              EDEFDICT.prev:deffilelinepos[1]+"("+;
              toStr(EDEFDICT.prev:deffilelinepos[2])+")"
      this:errorGen(mnameToken,HPRERR_MDUPLICATE,{name,errStr})
   endif

return nil

//*******************************************************************
function hpr_prsIfdef(this,mnameToken,ifdefType)
// A #ifdef/#ifndef  elemzje.

local state

#ifdef ID_STRING
   #define ST_FD_START             "start"
   #define ST_FD_VEGE              "vege"
#else
   #define ST_FD_START             1
   #define ST_FD_VEGE              2
#endif

local tkId,tkStr
local name
local ujsor
local megvan

   state:=ST_FD_START
   this:rds()
   while(this:item!=nil)    
      tkId:=TOKEN.(this:item):id
      tkStr:=TOKEN.(this:item):str
      ujsor:=tkId==TKID_UJSOR .or.;
             tkId==TKID_BOS .or. tkId==TKID_EOS
      if (state==ST_FD_START)
         if (ujsor)
            // Hibs s vge is van.
            this:errorgen(mnameToken,HPRERR_IFDEFNL)
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         elseif (tkId==TKID_NEV)
            // Ez a neve
            name:=tkStr
            state:=ST_FD_VEGE
         else
            // Hibs.
            this:errorgen(this:item,HPRERR_SIFDEF)
            exit
         endif
      elseif (state==ST_FD_VEGE)
         if (ujsor)
            // Ksz vagyunk.
            this:unrds()
            this:clearParserbuffer()
            if (ifdefType==IFDEFTYPE_NONE)
               // Hamis gban lev if.
               this:branch:=nil
               aadd(this:ifStack,{IFB_NONEBRANCH,this:branch})
               this:sorNyel()
            else
               megvan:=DEFDICT.(this:defdict):atKey(name)
               this:branch:=if(ifdefType==IFDEFTYPE_IFDEF,megvan!=nil,megvan==nil)
               aadd(this:ifStack,{IFB_IFBRANCH,this:branch})
            endif
            exit
         elseif (tkId==TKID_URES)
            // Maradunk.
         else
            // Hibs
            this:errorgen(this:item,HPRERR_SIFDEF)
            exit
         endif
      else
         ? "HPARSER:parseIfdef(): Ismeretlen llapot: ",state
         errorlevel(1)
         quit
      endif
      this:rds()
   end while
   this:sorNyel()
   
return nil

//*******************************************************************
function hpr_prsElse(this,mnameToken)
// A #else  elemzje.
local w

   if (len(this:ifStack)<=0)
      // Hiba, nincs hozz if.
      this:errorgen(this:item,HPRERR_ELSE) // Nincs hozz if
   elseif (this:branch!=nil)
      w:=atail(this:ifStack)
      // A spec-ben tbb else is lehet, ilyenkor csak megfordtja a 
      // felttelt.
      if (w[1]==IFB_IFBRANCH)
         w[1]:=IFB_ELSEBRANCH
      else
         // Dupliklt else, A spec-ben ez nem hiba!
         this:incompErrorgen(this:item,HPRERR_ELSE2) // Dupliklt else
      endif
      this:branch:=w[2]:=!w[2]
   endif
   this:sorNyel()
   
return nil


//*******************************************************************
function hpr_prsEndif(this,mnameToken)
// A #endif  elemzje.
local w

   if (len(this:ifStack)<=0)
      // Hiba, nincs hozz if.
      this:errorgen(this:item,HPRERR_ENDIF) // Nincs hozz if
   else
      adrop(this:ifStack)
      if (len(this:ifStack)<=0)
         this:branch:=.t.
      else
         w:=atail(this:ifStack)
         this:branch:=w[2]
      endif
   endif
   this:sorNyel()
   
return nil

//*******************************************************************



