//
// $Id: nparser.cls,v 1.1 1999/11/09 01:37:25 vszel Exp $
//

//*******************************************************************
// nparser.cls: Nv elemz. A PARSER-tl rkl.
// 1999, Csiszr Levente

// Ez az elemz vgzi el az alapvet elemzseket, felbontja az input
// stream-et a kvetkez tokenekre:
//   - Nv
//   - szmsor (nincs benne pont '.')
//   - res
//   - Megjegyzs (csillag, perper, percsillag)
//   - String (macskakrms, idzjeles)
//   - jsor
//   - Karakter.
//   Az egyb tokenek mindig pontosan egy karakteresek.

// A karaktereken kvl megrti a kvetkez egysgeket:
// CTK_BOS,CTK_EOS,CTK_PRINTLINE
// Az EOS-ra kld egy j sor karatert

// Mj.: A ';' kezelst s a sor sszevonsokat az lparser elemz
// csinlja.

class NPARSER PARSER
   
   // attrib item
   // attrib buf 
   attrib soreleje
   attrib tokenPos // Egy j token olvassakor a {file,line,pos}-t
                   // ide letesszk. A makeToken ebbl dolgozik.
      
   rmethod readItem()
   // Olvas egy elemet. 
   // Ret: Az elem, ha OK, nil, ha vge van a streamnek, vagy ha
   //      hiba volt.

   nmethod strEolParserBuffer()
   // Megadja a parserBuffer tartalmt stringknt.
   // A nem stringeket az eol kivtelvel eldobja.
   
   nmethod makeToken(tkId,str)
   // Kszt egy tkId tpus tokent 'str' tartalommal.
                      
   nmethod makeTokenSt(tkId,stArray)
   // Kszt egy tkId tpus tokenstr-t az stArray-nak megfelelen.
   
   nmethod makeTokenLSt(tkId,stArray)
   // Kszt egy tkId tpus tokenstr-t az stArray-nak megfelelen.
   // A str-be berja a #line sort, ha a mlysg vagy a sorszm 
   // nagyobb, mint 1.
   
   
   nmethod makeErrToken(tkId,str,errCode)
   // Kszt egy tkId tpus tokent 'str' tartalommal s errCode 
   // hibakddal.
                   
   nmethod parseTPTree()
   
   nmethod parse()
   // Ez vgzi a tnyleges elemzst, rekurzvan is lehet hvni.
   // A this:item-t elemzi, szksg esetn mg olvashat.
   
   nmethod parseLineComment(tkId)
   // '//' vagy '*' megjegyzs
   
   nmethod parsePcComment()
   // '/*'-os megjegyzs
   
   nmethod parseString(hatarolo)
   // Felsvesszs s macskakrms string.
   
   nmethod parseName()
   // Nv.
   
   nmethod parseNumberArray()
   // Szm sor. Ebben csak szmok vannak, pont nem lehet.



   rmethod oinit(inputReader,name,errorStream)
   
metaclass
   
   rmethod onew(inputReader,name,errorStream)
   
   attrib whitespacechar
   // attrib specchar
   attrib startnamechar
   attrib numberchar
   attrib namechar
   
   attrib tokens
   attrib tokenptree
   
   rmethod oinitclass()

   nmethod isWhitespacechar(c)
   // nmethod isSpecchar(c)
   nmethod isStartnamechar(c)
   nmethod isNumberchar(c)
   nmethod isNamechar(c)
   
   nmethod setTokens()
   // Feltlti a class:tokens vltozt az osztlyban definilt 
   // tokenekkel.

   nmethod calcTokenPTree()
   // Kszt egy elemz ft a tokenek elemzshez a 
   // class:tokenPTree-be.

